package com.huimv.eco.sgd;


import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.huimv.eco.entity.*;
import com.huimv.eco.service.*;
import com.huimv.eco.sgd.fbox.models.BoxStateChanged;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@Component
public class SaveData {

//    @Autowired
//    private IBaseRoomService baseRoomService;
//
//    @Autowired
//    private ISysHumidityService humidityService;
//
//    @Autowired
//    private ISysTemperatureService temperatureService;
//
//    @Autowired
//    private ISysFodderService fodderService;


    public void savData(BoxStateChanged stateChange){
        RestTemplate restTemplate = new RestTemplate();

        HumAndTemDto humAndTemDto = new HumAndTemDto();
        humAndTemDto.setType(1);
        humAndTemDto.setStateChange(stateChange);

        restTemplate.postForEntity("http://120.27.234.126:8010/receiver/receiver/eco/save",humAndTemDto,String.class);
    }


    public void savData(JsonArray jsonElements ,Long Uid){


        for (JsonElement jsonElement : jsonElements) {
            JsonObject item = jsonElement.getAsJsonObject();
            String name = item.get("name").getAsString();
            String gname = item.get("gname").getAsString();
            if ("房间状态".equals(gname)){
                if (name.contains("平均温度")){
//                    System.out.println(name);
                    RestTemplate restTemplate = new RestTemplate();

                    Map<String,Object> map = new HashMap();
                    map.put("item",item.toString());
                    map.put("Uid",Uid);
                    restTemplate.postForEntity("http://127.0.0.1:10001/test/test",map,String.class);


//                BaseRoom box_id = baseRoomService.getOne(new QueryWrapper<BaseRoom>().eq("box_id", Uid));
//                SysTemperature sysTemperature = new SysTemperature();
//                sysTemperature.setCreateTime(new Date(item.get("id").getAsLong()));
//                sysTemperature.setRoomId(box_id.getId());
//                sysTemperature.setOriginal(item.get("value").getAsDouble());
//                sysTemperature.setValue(item.get("value").getAsDouble()*0.1);
//                sysTemperature.setFarmId(1);
//                sysTemperature.setId(item.get("id").getAsString());
//
//                temperatureService.save(sysTemperature);
//                System.out.println(jsonElements+"Uid = "+Uid);
                }

                if (name.contains("日用水量")) {
//                    System.out.println(name);
                    RestTemplate restTemplate = new RestTemplate();

                    Map<String, Object> map = new HashMap();
                    map.put("item", item.toString());
                    map.put("Uid", Uid);
                    restTemplate.postForEntity("http://127.0.0.1:10001/test/test", map, String.class);
                }

                 if (name.contains("湿度")){
//                     System.out.println(name);
                    RestTemplate restTemplate = new RestTemplate();
                    Map<String,Object> map = new HashMap();
                    map.put("item",item.toString());
                    map.put("Uid",Uid);
                    restTemplate.postForEntity("http://127.0.0.1:10001/test/test",map,String.class);

//                BaseRoom box_id = baseRoomService.getOne(new QueryWrapper<BaseRoom>().eq("box_id", Uid));
//                SysHumidity sysHumidity = new SysHumidity();
//                sysHumidity.setCreateTime(new Date(item.get("id").getAsLong()));
//                sysHumidity.setRoomId(box_id.getId());
//                sysHumidity.setValue(( Math.round(item.get("value").getAsDouble() * 100)*0.01));
//                sysHumidity.setFarmId(1);
//                sysHumidity.setId(item.get("id").getAsString());
//
//                humidityService.save(sysHumidity);
//                System.out.println(jsonElements+"Uid = "+Uid);
                }

                //String oneUid = "-1277226674647203111";
                //        String twoUid = "-1277176930335980834";
                //        String threeUid = "-1277075358654397725";
            }
            if ("设备状态".equals(gname)){
                if (name.contains("累计重量")){
                    if (-1277226674647203111L == Uid){

                        saveFodder(item,1,Uid);

                    }
                    if (-1277176930335980834L == Uid) {
                        saveFodder(item,2,Uid);
                    }
                    if (-1277075358654397725L == Uid){
                        saveFodder(item,3,Uid);
                    }

                }
            }

        }
    }

    private void saveFodder(JsonObject item, int floorId,Long Uid) {

        RestTemplate restTemplate = new RestTemplate();
        Map<String,Object> map = new HashMap();
        map.put("item",item.toString());
        map.put("Uid",Uid);
        restTemplate.postForEntity("http://127.0.0.1:10001/test/test",map,String.class);

    }

}
