package com.huimv.environ;

import com.huimv.environ.server.EartagServer2;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.ApplicationContext;

/**
 * @Project : huimv-farm-device
 * @Package : ${}
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2022/11/30
 **/
@SpringBootApplication
@MapperScan("com.huimv.environ.mapper")
public class HuimvEnvironInputApplication {
    public static void main(String[] args) throws InterruptedException {
        ApplicationContext applicationContext = SpringApplication.run(HuimvEnvironInputApplication.class, args);
        applicationContext.getBean(EartagServer2.class).run();
    }
}
